<?php
/**
 *  产品属性
 *  @author  system
 *  @version    1.0
 *  @date 2018-07-03 16:51:48
 *
 */
namespace App\Http\Controllers\Admin\Album\Product;
use App\Http\Controllers\Admin\Controller;
use App\Models\AlbumProductAttrModel;
use Illuminate\Http\Request;
use App\Repositories\Base\Criteria\OrderBy;
use App\Repositories\Album\Product\Criteria\MultiWhere;
use App\Repositories\Album\Product\AttrRepository;

class AttrController extends Controller
{
    private $repository;

    public function __construct(AttrRepository $repository) {
        if(!$this->repository) $this->repository = $repository;
    }

    function index(Request $request) {
        $search['keyword'] = $request->input('keyword');
        $search['storeid'] = $this->getStoreId();

        $order = array();
        if(isset($request['sort_field']) && $request['sort_field'] && isset($request['sort_field_by'])) {
            $order[$request['sort_field']] = $request['sort_field_by'];
        }else{
            $order['updated_at']='DESC';
        }

        $list = $this->repository->searchAttr($search,$order);

        return view('admin.album.product.attr.index',compact('list'));
    }


    function check(Request $request) {
        $request = $request->all();
        $search['keyword'] = $request->input('keyword');
        $orderby = array();
        if(isset($request['sort_field']) && $request['sort_field'] && isset($request['sort_field_by'])) {
            $orderby[$request['sort_field']] = $request['sort_field_by'];
        }
        $list = $this->repository->search($search,$orderby);
        return view('admin.album.product.attr.check',compact('list'));
    }


    /**
     * 添加
     * 
     */
    public function create(Request $request)
    {
        if($request->method() == 'POST') {
            return $this->_createSave();
        }
        $list = AlbumProductAttrModel::genAreaTree($this->getStoreId(),2);

        return view('admin.album.product.attr.edit',compact('list'));
    }

    /**
     * 保存修改
     */
    private function _createSave(){
        $data = (array) request('data');
        $data['store_id'] = $this->getStoreId();
        $data['attr_type'] = $this->getattrtype(request('pid'));

        $id = $this->repository->create($data);
        if($id) {
            $url[] = array('url'=>U( 'Album/Product/Attr/index'),'title'=>'返回列表');
            $url[] = array('url'=>U( 'Album/Product/Attr/create'),'title'=>'继续添加');
            $this->showMessage('添加成功',$url);
        }else{
            $url[] = array('url'=>U( 'Album/Product/Attr/index'),'title'=>'返回列表');
            return $this->showWarning('添加失败',$url);
        }
    }
    
    /**
     * 
     * 修改
     * 
     * 
     */
    public function update(Request $request) {
        if($request->method() == 'POST') {
            return $this->_updateSave();
        }
        $data = $this->repository->find($request->get('id'));
        $list = AlbumProductAttrModel::genAreaTree($this->getStoreId(),2);

        return view('admin.album.product.attr.edit',compact('data','list'));
    }

    /**
     * 保存修改
     */
    private function _updateSave() {
        $data = (array) request('data');
        $ok = $this->repository->update(request('id'),$data);
        if($ok) {
            $url[] = array('url'=>U( 'Album/Product/Attr/index'),'title'=>'返回列表');
            return $this->showMessage('操作成功',urldecode(request('_referer')));
        }else{
            $url[] = array('url'=>U( 'Album/Product/Attr/index'),'title'=>'返回列表');
            return $this->showWarning('操作失败',$url);
        }
    }

    public function view(Request $request) {
        $data = $this->repository->find(request('id'));
        return view('admin.album.product.attr.view',compact('data'));
    }


    /**
     *
     * 状态改变
     *
     */
    public function status(Request $request) {
        $ok = $this->repository->updateStatus(request('id'),request('status'));
        if($ok) {
            return $this->showMessage('操作成功');
        }else{
            return $this->showWarning('操作失败');
        }
    }
    
    /**
     * 删除
     */
    public function destroy(Request $request) {
        $bool = $this->repository->destroy($request->get('id'));
        if($bool) {
            return  $this->showMessage('操作成功');
        }else{
            return  $this->showWarning("操作失败");
        }
    }

    private function getattrtype($pid)
    {
        if($pid){
            $attr_type = AlbumProductAttrModel::find($pid)->attr_type;
            return $attr_type + 1;
        }else{
            return 0;
        }
    }
}